<?php

/**
 * co_liquida_contrato actions.
 *
 * @package    contratacion
 * @subpackage co_liquida_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_liquida_contratoActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_LIQUIDA_CONTRATO','CO_CONTRATO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato' => 'CO_LIQUIDA_CONTRATO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_LIQUIDA_CONTRATO' =>
       array(
            'id_liquida_contrato' => 'id_liquida_contrato',
            'id_contrato' => 'id_contrato',
            'fecha_solicitud' => 'fecha_solicitud',
            'no_solicitud' => 'no_solicitud'
        ),
        'CO_CONTRATO_V' =>
        array(
            'no_contrato' => 'no_contrato',
            'id_anhos' => 'id_anhos',
            'completo_proceso' => 'completo_proceso',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_terminacion' => 'fecha_terminacion',
            'valor' => 'valor_contrato',
            'completo_contra' => 'completo_contra',
            'completo_super' => 'completo_super'
            )
           
        
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_LIQUIDA_CONTRATO' =>
        array(    
            'id_liquida_contrato,a' => array('!=' => array(-1)),
            'id_liquida_contrato,b' => array('=' => array('id_liquida_contrato')),
            'id_contrato,b' => array('=' => array('id_contrato')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_liquida_contrato'; //identificador de la tabla
    protected $id_names = array('id_liquida_contrato'); //llave primaria
    protected $field_names = array('id_contrato','fecha_solicitud','no_solicitud'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_LIQUIDA_CONTRATO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_liquida_contrato'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
                
                $id_contrato = $list_data_post[0]['id_contrato'];
                $sql = <<<EOD
                        UPDATE CO_CONTRATO SET LIQUIDADO=1 WHERE ID_CONTRATO = $id_contrato
EOD;
                        
            $this->conn->execute($sql);
                
            $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
             
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        $id_contrato = $request['id_contrato'];
        
        $sql = <<<EOD
        select count(*) as cantidad from co_documento_liquidacion tab0
                join co_tipo_doc_liq tab1 ON tab1.id_tipo_doc_liq = tab0.id_tipo_doc_liq and tab1.estado =1
                where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $documentos_liquida = $records[0]['cantidad'];


            $sql = <<<EOD
        select count(*) as cantidad from co_tipo_doc_liq
                where estado = 1
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $documentos_mod = $records[0]['cantidad'];

            if ($documentos_liquida < $documentos_mod) {

                $errors['mensaje'] = "No ha realizado el registro de todos los documentos para solicitar la liquidacion";
                $errors['servicio'] = "co_liquida_contrato";
            }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    } 
}
